#!/usr/bin/php
<?php
if($argc < 2) 
	exit("Usage: ".$argv[0]." FILE\n");

function test($a) {
	#echo "> $a - ",html_entity_decode($a, ENT_NOQUOTES, 'UTF-8'),"\n";
	
	return html_entity_decode($a, ENT_NOQUOTES, 'UTF-8');
}

function xml_entities($text, $charset = 'UTF-8'){
     // Debug and Test
    // $text = "test &amp; &trade; &amp;trade; abc &reg; &amp;reg; &#45;";
   
    // First we encode html characters that are also invalid in xml
    $text = htmlentities($text, ENT_NOQUOTES, $charset, false);
   
    // XML character entity array from Wiki
    // Note: &apos; is useless in UTF-8 or in UTF-16
    $arr_xml_special_char = array("&quot;","&amp;","&apos;","&lt;","&gt;");
   
    // Building the regex string to exclude all strings with xml special char
    $arr_xml_special_char_regex = "(?";
    foreach($arr_xml_special_char as $key => $value){
        $arr_xml_special_char_regex .= "(?!$value)";
    }
    $arr_xml_special_char_regex .= ")";
   
    // Scan the array for &something_not_xml; syntax
    $pattern = "/$arr_xml_special_char_regex(&[a-zA-Z0-9]+;)/e";
   
    // Replace the &something_not_xml; with &amp;something_not_xml;
    $replacement = 'test(\'${1}\')';
    return preg_replace($pattern, $replacement, $text);
}

$infile = $argv[1];
if (file_exists($infile)) {
	$xml = simplexml_load_file($infile);
	$root_nodes = $xml->children();

	$worksheet_nodes = NULL;
	foreach ( $root_nodes as $key => $value ) {
       if($key == "Worksheet") {
       	$worksheet_nodes = $value->children();
       	break;
       }
	}
	
	if(!$worksheet_nodes)
		exit("Worksheet data not found!\n");
		

	$table_nodes = NULL;
	foreach ( $worksheet_nodes as $key => $value ) {
       if($key == "Table") {
       	$table_nodes = $value->children();
       	break;
       }
	}	
	
	if(!$table_nodes)
		exit("Table data not found!\n");

	$row = array();
	$data = array();
	$x=0;
	foreach ( $table_nodes as $key => $value ) {
		if($key == "Row") {
			$row_node = $value->children();
			$i=0;
			foreach ( $row_node as $_key => $_value ) {
       			foreach($_value as $name => $node) {
       				if($x == 0) {
       					if(!$node) continue;
       					$row[(string) $node] = "";
       				} else {
       					if(!$node) continue;
						$keys = array_keys($row);
						$row[$keys[$i++]] = trim((string) $node);
       				}
       			}
			}
			$x++;
			
			if($row['name'])
				$data[] = $row;
			
			foreach ( $row as $key => $value )
       			$row[$key] = "";
		}   
	}
	
	if(count($data) < 1)
		exit("No valueable data found in file " .$infile.".");
		
	$srxml = new SimpleXMLElement("<?xml version='1.0' encoding='utf-8'?><srdata></srdata>");

	$i = 0;
	foreach ( $data as $key => $value ) {
		foreach($value as $k => $v) {
			$value[$k] = xml_entities($v);
			//var_dump($value[$k]);
		}

		if(in_array("ibh_router_telnet_pw", array_keys($value))) {
			// IBHCust data
			if(file_exists("names.inc.php")) {
				require_once("names.inc.php");
			} else {
				$ids = array();
			}			
			
			$ce = $srxml->addChild("ce");
			
			$id = $ids[$value["name"]] ? $ids[$value["name"]] : "Not found ".$i++;
			
			$ce->addChild("id", $id);
			$ce->addChild("subject", "[Notes: IBHCust] ". $value["name"]);
			$ce->addChild("descr", "Imported from Lotus Notes.");
			$cd = $ce->addChild("cd");
		
			$txt = "&lt;b&gt;Confidential Data for ".$value["name"]. "&lt;/b&gt;";
			$txt.= "\n\nRouter telnet Password:\t\t\t\t\t" . $value["ibh_router_telnet_pw"] . "\t" .$value["router_ip"] ;
			$txt.= "\nRouter Passwords:\t\t\t\t\t\t" . $value["ibh_router_password"];
			$txt.= "\nRouter Config saved:\t\t\t\t\t" . $value["ibh_router_saved_config"];
			$txt.= "\nRouter Read Community:\t\t\t\t\t" . $value["ibh_router_rcomm"];
			$txt.= "\nRouter R/W Community:\t\t\t\t\t" . $value["ibh_router_rwcomm"];
			$txt.= "\nRouter Authorization (IBH-rcv):\t\t\t" . $value["ibh_router_auth_ibh"];
			$txt.= "\nRouter Authorization (Cust-rcv):\t\t" . $value["ibh_router_auth_cust"];
			$txt.= "\nAccount Info (node/ name/ password):\t" . $value["ibh_account"];
			$txt.= "\nWEB account";
			$txt.= "\n(service/ node:port/ password):\t\t" . $value["web_service"] . "/ " . $value["web_node"] . "/ " . $value["web_name"] . "/ " . $value["web_pass"];
			$txt.= "\nMailboxen (Name (mailboxen)/ password):\t" . $value["ibh_mbx1"] . "\t". $value["ibh_mbx6"]. "\t". $value["ibh_mbx11"]. "\t". $value["ibh_mbx16"];
			$txt.= "\n\t\t" . $value["ibh_mbx2"] . "\t". $value["ibh_mbx7"]. "\t". $value["ibh_mbx12"]. "\t". $value["ibh_mbx17"];
			$txt.= "\n\t\t" . $value["ibh_mbx3"] . "\t". $value["ibh_mbx8"]. "\t". $value["ibh_mbx13"]. "\t". $value["ibh_mbx18"];
			$txt.= "\n\t\t" . $value["ibh_mbx4"] . "\t". $value["ibh_mbx9"]. "\t". $value["ibh_mbx14"]. "\t". $value["ibh_mbx19"];
			$txt.= "\n\t\t" . $value["ibh_mbx5"] . "\t". $value["ibh_mbx10"]. "\t". $value["ibh_mbx15"]. "\t". $value["ibh_mbx20"];
			$txt.= "\n\nCreator / Changer:\n" . $value["history_confidential"];
			
			// Retrieve the last timestamp.
			$tstamp = date("Y-m-d H:i:s");
			if($value["history_confidential"]) {
				$v = $value["history_confidential"];
				foreach ( explode("\r", $value["history_confidential"]) as $v ) {
					if(!$v) continue;
					preg_match("/\d+[\.\/]\d+[\.\/]\d+\ \d+:\d+:\d+/", $v, $matches);
					$date = str_replace('/', '-', $matches[0]);
				
					if(strtotime($date)) {
						$tstamp = date("Y-m-d H:i:s", strtotime($date));
						break;
					}
				}
			}
			
			$cd->addChild("tstamp", $tstamp);
			$cd->addChild("data", $txt);			

		} else if(in_array("display_name", array_keys($value))) {
			// WWWCust data
			if(file_exists("wwwnames.inc.php")) {
				require_once("wwwnames.inc.php");
			} else {
				$ids = array();
			}						
			
			$ce = $srxml->addChild("ce");
			
			$id = $ids[$value["name"]] ? $ids[$value["name"]] : "Not found ".$i++;
			
			$ce->addChild("id", $id);
			$ce->addChild("subject", "[Notes: WWWCust] ". $value["display_name"]);
			$ce->addChild("descr", "Imported from Lotus Notes.");
			$cd = $ce->addChild("cd");
			
			$txt = "&lt;b&gt;".$value["display_name"]. "&lt;/b&gt;";
			$txt.= "\n\nServer Name:\t\t\t" . $value["server_name"] . " on " .$value["display_host"] ;
			$txt.= "\nStatus:\t\t\t\t\t" . $value["status"];
			$txt.= "\nServer Host:\t\t\t" . $value["server_host"];
			$txt.= "\nServer IP:\t\t\t\t" . $value["server_ip"];
			$txt.= "\nNetname 0:\t\t\t\t\t" . $value["netname0"];
			$txt.= "\n\n&lt;i&gt;Remarks:&lt;/i&gt;\n" . $value["bemerkungen"];
			$txt.= "\n\n&lt;i&gt;Confidential Data:&lt;/i&gt;";
			$txt.= "\nUser Name FTP Account:\t\t\t" . $value["ftp_user"] . " on " . $value["ftp_host"];
			$txt.= "\nPassword FTP Account:\t\t\t" . $value["ftp_passwd"];
			$txt.= "\nChange Root FTP Account:\t\t" . $value["ftp_chroot"];
			$txt.= "\nMySQL Database/ Name/ Password:\t" . $value["mysqldatabase"] . "/" . $value["sql_name"] . "/" . $value["sql_passw"] ;
			$txt.= "\n\nAccount Info (node/ name/ password):\t";
			$txt.= "\n". $value["accountinfo"];
			$txt.= "\n\n&lt;i&gt;WEB account (service/ node:port/ password):&lt;/i&gt;\t";
			$txt.= "\n". $value["webaccount"];
			$txt.= "\n\nUser Name FW Account:\t\t" . $value["fw_user"];
			$txt.= "\nPassword FW Account:\t\t" . $value["fw_passwd"];
			
			$tstamp = date("Y-m-d H:i:s");

			$cd->addChild("tstamp", $tstamp);
			$cd->addChild("data", $txt);
		}

	}

	echo $srxml->asXML();
} else {
	exit("Failed to open ".$infile.".\n");
}
