package de.ibh.RandomArt;

import java.security.InvalidParameterException;
import java.util.List;

public abstract class AbstractRAOperator implements Cloneable {
	protected RAPRNG prng;
	protected List<AbstractRAOperator> ops;

	public AbstractRAOperator(RAPRNG prng) {
		this.prng = prng;
	}

	public abstract int getArity();
	public abstract double[] eval(final double x, final double y);
	
	public void init(List<AbstractRAOperator> ops) {
		if((ops == null && getArity() != 0) || (ops != null && ops.size() != getArity()))
			throw new InvalidParameterException();

		this.ops = ops;
	}
	
	@Override
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			assert(false);
		}
		
		return null;
	}
	
	public List<AbstractRAOperator> getOps() {
		return ops;
	}
}
