/**
 * 
 */
package de.ibh.StrongRoom.Client.Config;

import de.ibh.StrongRoom.Crypto.CryptoBackend.ECryptoPGP_KeyType;

public class WindowConf extends AbstractConf {
    private static final String SRP_WINDOW_X = "StrongRoom.Window.x";
    private static final String SRP_WINDOW_Y = "StrongRoom.Window.y";
    private static final String SRP_WINDOW_WIDTH = "StrongRoom.Window.width";
    private static final String SRP_WINDOW_HEIGHT = "StrongRoom.Window.height";
    private static final String SRP_WINDOW_DEBUG = "StrongRoom.Window.debug";
    private static final String SRP_WINDOW_COLLAPSELIST = "StrongRoom.Window.collapselist";
    private static final String SRP_WINDOW_HIGHLIGHTALL = "StrongRoom.Window.highlightall";

    protected static String confname = "window";
   
	static private WindowConf conf = null;
    
    static public WindowConf getInstance() {
        if(conf != null)
        	return conf;
        
        return conf = new WindowConf(true);
    }

    private WindowConf(boolean silent) {
   		super(true);
	}

	@Override
	public String getConfName() {
		return "window";
	}


    public int[] getWindowBounds() {
        int dim[] = new int[4];
        
        if(prop.isEmpty()) {
        	dim[0] = 0;
        	dim[1] = 0;
        	dim[2] = 800;
        	dim[3] = 600;
        }
        else {
        	dim[0] = Integer.parseInt(prop.getProperty(SRP_WINDOW_X, "0"));
        	dim[1] = Integer.parseInt(prop.getProperty(SRP_WINDOW_Y, "0"));
        	dim[2] = Integer.parseInt(prop.getProperty(SRP_WINDOW_WIDTH, "800"));
        	dim[3] = Integer.parseInt(prop.getProperty(SRP_WINDOW_HEIGHT, "600"));
        }
        
        return dim;
    }
    
    public boolean getCollapseList() {
        boolean collapse = false;
        
        if(prop.isEmpty())
            collapse = false;
        else
            collapse = Boolean.parseBoolean(prop.getProperty(SRP_WINDOW_COLLAPSELIST, "false"));
        
        return collapse;
    }
    
    public boolean getHighLightAll() {
        boolean highlight = false;
        
        if(prop.isEmpty())
            highlight = false;
        else
            highlight = Boolean.parseBoolean(prop.getProperty(SRP_WINDOW_HIGHLIGHTALL, "false"));
        
        return highlight;
    }    
   
    public void setWindowBounds(int dim[]) {
        prop.setProperty(SRP_WINDOW_X, Integer.toString(dim[0]));
        prop.setProperty(SRP_WINDOW_Y, Integer.toString(dim[1]));
        prop.setProperty(SRP_WINDOW_WIDTH, Integer.toString(dim[2]));
        prop.setProperty(SRP_WINDOW_HEIGHT, Integer.toString(dim[3]));
    }
    
    public void setCollapseList(boolean collapse) {
        prop.setProperty(SRP_WINDOW_COLLAPSELIST, Boolean.toString(collapse));
    }
    
    public void setHighlightAll(boolean highlight) {
        prop.setProperty(SRP_WINDOW_HIGHLIGHTALL, Boolean.toString(highlight));        
    }

    public boolean getDebug() {
        return Boolean.parseBoolean(prop.getProperty(SRP_WINDOW_DEBUG, "0"));
    }

    
	@Override
	public ECryptoPGP_KeyType getSignKeyType() {
		return null;
	}

	@Override
	public String getSignString() {
		return null;
	}
}