package de.ibh.StrongRoom.DB;

import java.util.HashMap;
import java.util.Map;

import de.ibh.StrongRoom.Crypto.CryptoBackend.ECryptoPGP_KeyType;

public class SigningKey implements ISignedRow {
    private long serial;
    private String pubKey;
    private String signMKey;
    
    SigningKey(final long serial, final String pubKey, final String signMKey) {
        this.serial = serial;
        this.pubKey = pubKey;
        this.signMKey = signMKey;
    }

    
    public long getSerial() {
        return serial;
    }
    
    public String getPubKey() {
    	return pubKey;
    }

	@Override
	public String[] getSignStrings() {
		return new String[] {Long.toString(serial), pubKey};
	}

	@Override
	public Map<ECryptoPGP_KeyType, String> getSignKeyMap() {
		Map<ECryptoPGP_KeyType, String> m = new HashMap<ECryptoPGP_KeyType, String>();

		m.put(ECryptoPGP_KeyType.MASTER_KEY, signMKey);

		return m;
	}


	@Override
	public void setSigningData(ECryptoPGP_KeyType kt, String sig) {
		if(kt == ECryptoPGP_KeyType.MASTER_KEY)
			signMKey = sig;
		else
			throw new IllegalArgumentException();
	}
}
