/**
 * 
 */
package de.ibh.StrongRoom.l10n;

import java.util.Locale;

import java.util.ListResourceBundle;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import de.ibh.StrongRoom.Log.DebugMessage;

/**
 * @author ellguth
 *
 */
public class StrongRoomL10N extends ListResourceBundle {
    private ResourceBundle res;
    static private StrongRoomL10N lang = null;
    private DebugMessage logger = DebugMessage.getInstance();

    protected StrongRoomL10N() {
        try {
            res = ResourceBundle.getBundle(getClass().getName(), Locale.getDefault());
        }
        catch(MissingResourceException e) {
            res = this;
        }
    }
    
    public String _(String key) {
        String value;
        
        try {
            value = res.getString(key);
        } catch (MissingResourceException e) {
            value = key;
            if(res != this) 
                logger.debug("Missing localization for key: \"" + key + "\"");
        }
        
        return value;
    }
    
    static public StrongRoomL10N getInstance() {
        if (lang != null)
            return lang;

        lang = new StrongRoomL10N();
        
        return lang;
    }

    /* (non-Javadoc)
     * @see java.util.ListResourceBundle#getContents()
     */
    @Override
    protected Object[][] getContents() {
        // TODO Auto-generated method stub
        return new Object[0][0];
    }

    
}
